> ## Documentation Index
> Fetch the complete documentation index at: https://docs.bluvo.dev/llms.txt
> Use this file to discover all available pages before exploring further.

# Tradable Assets

> List tradable assets and trading routes for an exchange. Provide either the x-bluvo-wallet-id header or the exchange query parameter. When both are provided, the wallet header wins and the wallet exchange is used. Optional source and destination filters limit the returned routes and prune the assets list to assets referenced by those routes.

**Required API Key Scopes:** `read`



## OpenAPI

````yaml https://api-bluvo.com/api/v0/openapi get /v0/wallet/trade/tradable-assets
openapi: 3.1.0
info:
  title: Bluvo API (v0)
  description: APIs to supercharge your crypto project.
  version: 0.0.3
  termsOfService: https://bluvo.co/terms
  contact:
    name: Bluvo
    email: help@bluvo.co
    url: https://bluvo.co
servers:
  - url: https://api-bluvo.com
    description: Production Server
  - url: https://test.api-bluvo.com
    description: Development Server
security: []
paths:
  /v0/wallet/trade/tradable-assets:
    get:
      tags:
        - Trading
      summary: Tradable Assets
      description: >-
        List tradable assets and trading routes for an exchange. Provide either
        the x-bluvo-wallet-id header or the exchange query parameter. When both
        are provided, the wallet header wins and the wallet exchange is used.
        Optional source and destination filters limit the returned routes and
        prune the assets list to assets referenced by those routes.


        **Required API Key Scopes:** `read`
      operationId: wallettradetradableassetstradableassets
      parameters:
        - name: exchange
          in: query
          required: false
          description: >-
            Exchange ID to read tradable assets for when x-bluvo-wallet-id is
            not provided.
          schema:
            type: string
            enum:
              - ace
              - ascendex
              - bequant
              - bigone
              - binance
              - binance-web
              - coinbase
              - binanceus
              - bingx
              - bit2c
              - bitbank
              - bitbns
              - bitcoincom
              - bitfinex
              - bitflyer
              - bitget
              - bithumb
              - bitmart
              - bitmex
              - bitopro
              - bitpanda
              - bitrue
              - bitso
              - bitstamp
              - bitteam
              - bitvavo
              - bybit
              - bybit-web
              - bl3p
              - blockchaincom
              - blofin
              - btcalpha
              - btcbox
              - btcmarkets
              - btcturk
              - cex
              - coincheck
              - coinex
              - coinlist
              - coinmate
              - coinmetro
              - coinone
              - coinsph
              - coinspot
              - cryptocom
              - delta
              - deribit
              - digifinex
              - exmo
              - fmfwio
              - gate
              - gateio
              - gemini
              - hashkey
              - hitbtc
              - hollaex
              - htx
              - huobi
              - huobijp
              - hyperliquid
              - independentreserve
              - indodax
              - kraken
              - krakenfutures
              - kucoin
              - kucoinfutures
              - latoken
              - lbank
              - luno
              - mercado
              - mexc
              - ndax
              - novadax
              - oceanex
              - okcoin
              - okx
              - onetrading
              - oxfun
              - p2b
              - paradex
              - paymium
              - phemex
              - poloniex
              - poloniexfutures
              - probit
              - timex
              - tradeogre
              - upbit
              - vertex
              - wavesexchange
              - whitebit
              - woo
              - woofipro
              - xt
              - yobit
              - zaif
              - zonda
              - local-cex
        - name: sources
          in: query
          required: false
          description: >-
            Comma-separated source/base assets to include, for example
            DOGE,USDC,BTC,ETH.
          schema:
            type: string
        - name: destinations
          in: query
          required: false
          description: >-
            Comma-separated destination/quote assets to include, for example
            USDT,BTC,SOL,ETH,DOGE.
          schema:
            type: string
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                type: object
                properties:
                  schemaVersion:
                    type: number
                    const: 1
                  exchange:
                    type: string
                  generatedAt:
                    type: string
                  source:
                    type: object
                    properties:
                      api:
                        type: string
                      fetchedAt:
                        type: string
                    required:
                      - api
                      - fetchedAt
                  assets:
                    type: array
                    items:
                      type: object
                      properties:
                        assetId:
                          type: string
                        symbol:
                          type: string
                        name:
                          type: string
                        assetType:
                          type: string
                        exchangeSymbols:
                          type: array
                          items:
                            type: string
                      required:
                        - assetId
                        - symbol
                        - exchangeSymbols
                  routes:
                    type: array
                    items:
                      type: object
                      properties:
                        routeId:
                          type: string
                        exchange:
                          type: string
                        marketType:
                          type: string
                          enum:
                            - spot
                            - margin
                            - futures
                            - perpetual
                            - unknown
                        baseAsset:
                          type: string
                        quoteAsset:
                          type: string
                        displaySymbol:
                          type: string
                        exchangeSymbol:
                          type: string
                        status:
                          type: string
                          enum:
                            - online
                            - offline
                            - trading
                            - halted
                            - cancel_only
                            - post_only
                            - limit_only
                            - auction
                            - unknown
                        isTradingEnabled:
                          type: boolean
                        margin:
                          type: object
                          properties:
                            isMarginEnabled:
                              type: boolean
                            maxLongLeverage:
                              type: number
                            maxShortLeverage:
                              type: number
                          required:
                            - isMarginEnabled
                        orderTypes:
                          type: array
                          items:
                            type: string
                            enum:
                              - market
                              - limit
                              - limit_maker
                              - stop_loss
                              - stop_loss_limit
                              - take_profit
                              - take_profit_limit
                              - trailing_stop
                              - unknown
                        tradingRules:
                          type: object
                          properties:
                            price:
                              type: object
                              properties:
                                tickSize:
                                  type: string
                                priceDecimals:
                                  type: number
                                minPrice:
                                  type: string
                                maxPrice:
                                  type: string
                            quantity:
                              type: object
                              properties:
                                minBaseQty:
                                  type: string
                                maxBaseQty:
                                  type: string
                                stepSize:
                                  type: string
                                quantityDecimals:
                                  type: number
                            notional:
                              type: object
                              properties:
                                minNotional:
                                  type: string
                                maxNotional:
                                  type: string
                                applyMinToMarket:
                                  type: boolean
                            marketQuantity:
                              type: object
                              properties:
                                minQty:
                                  type: string
                                maxQty:
                                  type: string
                                stepSize:
                                  type: string
                            orderLimits:
                              type: object
                              properties:
                                maxNumOrders:
                                  type: number
                                maxNumAlgoOrders:
                                  type: number
                                maxNumIcebergParts:
                                  type: number
                                maxNumOrderAmends:
                                  type: number
                        fees:
                          type: object
                          properties:
                            model:
                              type: string
                              const: maker_taker
                            tiers:
                              type: array
                              items:
                                type: object
                                properties:
                                  volume:
                                    type: string
                                  maker:
                                    type: string
                                  taker:
                                    type: string
                                required:
                                  - volume
                                  - maker
                                  - taker
                          required:
                            - model
                            - tiers
                      required:
                        - routeId
                        - exchange
                        - marketType
                        - baseAsset
                        - quoteAsset
                        - displaySymbol
                        - status
                        - isTradingEnabled
                        - margin
                        - orderTypes
                  rateLimits:
                    type: array
                    items:
                      type: object
                      properties:
                        type:
                          type: string
                        interval:
                          type: string
                        limit:
                          type: number
                      required:
                        - type
                        - interval
                        - limit
                  stats:
                    type: object
                    properties:
                      totalAssets:
                        type: number
                      totalRoutes:
                        type: number
                      tradableRoutes:
                        type: number
                    required:
                      - totalAssets
                      - totalRoutes
                      - tradableRoutes
                required:
                  - schemaVersion
                  - exchange
                  - generatedAt
                  - source
                  - assets
                  - routes
                  - stats
              example:
                schemaVersion: 1
                exchange: kraken
                generatedAt: '2026-06-01T00:00:00.000Z'
                source:
                  api: https://api.kraken.com/0/public/AssetPairs
                  fetchedAt: '2026-06-01T00:00:00.000Z'
                assets:
                  - assetId: DOGE
                    symbol: DOGE
                    exchangeSymbols:
                      - XXDG
                      - XDG
                  - assetId: USDC
                    symbol: USDC
                    exchangeSymbols:
                      - USDC
                routes:
                  - routeId: kraken:spot:DOGE-USDC
                    exchange: kraken
                    marketType: spot
                    baseAsset: DOGE
                    quoteAsset: USDC
                    displaySymbol: DOGE/USDC
                    exchangeSymbol: XDGUSDC
                    status: online
                    isTradingEnabled: true
                    margin:
                      isMarginEnabled: false
                    orderTypes:
                      - market
                      - limit
                    tradingRules:
                      price:
                        tickSize: '0.000001'
                        priceDecimals: 6
                      quantity:
                        minBaseQty: '13'
                        stepSize: '0.00000001'
                        quantityDecimals: 8
                    fees:
                      model: maker_taker
                      tiers:
                        - volume: '0'
                          maker: '0.25'
                          taker: '0.4'
                stats:
                  totalAssets: 2
                  totalRoutes: 1
                  tradableRoutes: 1
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                  type:
                    type: string
                    enum:
                      - GENERIC_NOT_FOUND
                      - GENERIC_UNAUTHORIZED
                      - GENERIC_INTERNAL_SERVER_ERROR
                      - GENERIC_VALIDATION_ERROR
                      - GENERIC_INVALID_REQUEST
                      - GENERIC_RATE_LIMIT_EXCEEDED
                      - APIKEY_INSUFFICIENT_PERMISSIONS
                      - WALLET_NOT_FOUND
                      - WALLET_INVALID_CREDENTIALS
                      - WALLET_IDENTITY_NOT_FOUND
                      - QUOTE_NOT_FOUND
                      - QUOTE_EXPIRED
                      - WITHDRAWAL_INSUFFICIENT_BALANCE
                      - WITHDRAWAL_INSUFFICIENT_BALANCE_FOR_FEE
                      - WITHDRAWAL_INVALID_ADDRESS
                      - WITHDRAWAL_NETWORK_NOT_SUPPORTED
                      - WITHDRAWAL_TOO_MANY_ADDRESSES
                      - WITHDRAWAL_FUNDING_ADDRESS_CONFLICT
                      - WITHDRAWAL_AMOUNT_BELOW_MINIMUM
                      - WITHDRAWAL_AMOUNT_ABOVE_MAXIMUM
                      - WITHDRAWAL_ASSET_NOT_SUPPORTED
                      - WITHDRAWAL_PROVIDER_ERROR
                      - WITHDRAWAL_2FA_REQUIRED_TOTP
                      - WITHDRAWAL_2FA_REQUIRED_SMS
                      - WITHDRAWAL_2FA_REQUIRED_FACE_RECOGNITION
                      - WITHDRAWAL_2FA_REQUIRED_EMAIL
                      - WITHDRAWAL_2FA_REQUIRED_YUBIKEY
                      - WITHDRAWAL_2FA_REQUIRED_PASSPHRASE
                      - WITHDRAWAL_2FA_REQUIRED_MULTI_STEPS
                      - WITHDRAWAL_2FA_INCOMPLETE
                      - WITHDRAWAL_2FA_INVALID
                      - WITHDRAWAL_2FA_METHOD_NOT_SUPPORTED
                      - WITHDRAWAL_KYC_REQUIRED
                      - WITHDRAWAL_EMAIL_UNVERIFIED
                      - WITHDRAWAL_RATE_LIMIT_EXCEEDED
                      - OAUTH_AUTHORIZATION_FAILED
                      - OAUTH_TOKEN_EXCHANGE_FAILED
                      - OAUTH_INVALID_STATE
                      - OAUTH_INSUFFICIENT_SCOPE
                      - OAUTH_QR_CODE_UNAVAILABLE
                      - OAUTH_COUNTRY_NOT_DETECTED
                      - OAUTH_COUNTRY_NOT_SUPPORTED
                      - OAUTH_COUNTRY_CODE_INVALID
                      - WEBHOOK_SIGNATURE_INVALID
                      - WEBHOOK_MISSING_HEADERS
                      - WEBHOOK_INVALID_TIMESTAMP
                      - CACHE_MISS
                      - CACHE_EXPIRED
                      - CACHE_INVALID_PATH
                      - DEPOSIT_NOT_IMPLEMENTED
                      - DEPOSIT_ASSET_REQUIRED
                      - DEPOSIT_NETWORK_REQUIRED
                      - DEPOSIT_METHODS_UNAVAILABLE
                      - DEPOSIT_ADDRESS_UNAVAILABLE
                      - DEPOSIT_EXCHANGE_NOT_SUPPORTED
                      - DEPOSIT_METHOD_NOT_RESOLVED
                      - WITHDRAWAL_DRY_RUN_COMPLETE
                      - TRADING_DATA_UNAVAILABLE
                      - TRADING_EXCHANGE_NOT_SUPPORTED
                      - TRADING_ROUTE_NOT_FOUND
                      - TRADING_ROUTE_UNAVAILABLE
                      - TRADING_ORDER_TYPE_NOT_SUPPORTED
                      - TRADING_ORDER_NOT_FOUND
                      - TRADING_PROVIDER_ERROR
                      - INFO_ASSET_REQUIRED
                      - INFO_FEE_EXCHANGE_NOT_SUPPORTED
                      - ENRICHMENT_NETWORK_NOT_SUPPORTED
                      - ENRICHMENT_TIMEOUT
                      - ENRICHMENT_API_ERROR
                  result: {}
                required:
                  - error
                  - type
              example:
                error: >-
                  Provide either x-bluvo-wallet-id header or exchange query
                  parameter
                type: GENERIC_VALIDATION_ERROR
        '403':
          description: Forbidden - Insufficient API key permissions
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                  type:
                    type: string
                    const: APIKEY_INSUFFICIENT_PERMISSIONS
                  missing:
                    type: array
                    items:
                      type: string
                required:
                  - error
                  - type
                  - missing
              example:
                error: Insufficient permissions
                type: APIKEY_INSUFFICIENT_PERMISSIONS
                missing:
                  - read
        '404':
          description: Not Found
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                  type:
                    type: string
                    const: WALLET_NOT_FOUND
                  result: {}
                required:
                  - error
                  - type
              example:
                error: Wallet not found
                type: WALLET_NOT_FOUND
      security:
        - bluvoApiKey:
            - x-bluvo-api-key
          bluvoOrgId:
            - x-bluvo-org-id
          bluvoProjectId:
            - x-bluvo-project-id
components:
  securitySchemes:
    bluvoApiKey:
      type: apiKey
      name: x-bluvo-api-key
      in: header
      description: Bluvo API Key
    bluvoOrgId:
      type: apiKey
      name: x-bluvo-org-id
      in: header
      description: Bluvo Organization ID
    bluvoProjectId:
      type: apiKey
      name: x-bluvo-project-id
      in: header
      description: Bluvo Project ID

````